% Grammatische Regeln für den Parser. Das "Herzstück" des Programms.
% AUTOR: Sebastian Behr

go2(T) :- [lex4], s(ErrStat,T,[der,schwanz,endet,in,einer,grossen,schwanzflosse],Rest), writeln(ErrStat), writeln(Rest).



%Merke: Reihenfolge Error-Status, Tree ist vertauscht!!!
s(Err,T)
-->
{initChainBundle(CB1)},
c2(1,CB1,empty,SubkatUP,RectDom,T,cpbesetzung(_,_,matrixsatz),Err),
{dStrukturSchlingeLeer(SubkatUP,Err)},
{allAlphasBound(RectDom)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   COMPLEMENTIZER
%
% Komponenten v2-Funktor: Segmentnr. Adjunktion, Kettenbündel, Subkategorisierungsliste DOWN, Subkategorisierungsliste UP, Rektionsdomäne, Baum, Satzartmerkmale, Fehlerstatus
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Nebensätze ins Vorfeld bewegt (Objekt an Spec-C'-Stelle)
c2(1,CB1,empty,SubkatUP,RectDom3,T3,CPbesetzung1,Err4)
-->
{rekursionsFilter(CPbesetzung1), initChainBundle(CB4), dStrukturSchlingeLeer(SubkatUP2,Err2),allAlphasBound(RectDom4)},
c2(1,CB4,empty,SubkatUP2,RectDom4,T1,cpbesetzung(_,_,nebensatz),Err1),
{inklusionsHorizont(CB1,CB2), openChain(obj,cp,mp(_,_,_,irr,_,_,_,_,_,_),CB2,CB3)},
{setSpecCP(cp,CPbesetzung1,CPbesetzung2)},
c1(CB3,empty,SubkatUP,RectDom1,T2,CPbesetzung2,Err2),
{newOmega(_,cp,RectDom1,RectDom2), closeRectDom(RectDom2,RectDom3,Err3)},
{tree('CP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.


%SPEC-C' unbesetzt
c2(1,CB1,empty,SubkatUP,RectDom2,T2,CPbesetzung1,Err3)
-->
{inklusionsHorizont(CB1,CB2)},
{setSpecCP(empty,CPbesetzung1,CPbesetzung2)},
c1(CB2,empty,SubkatUP,RectDom1,T1,CPbesetzung2,Err1),
{closeRectDom(RectDom1,RectDom2,Err2)},
{tree('CP',T1,T2)},
{mergeErrorStats(Err1,Err2,Err3)}.


%Escape Hatch
c2(1,CB1,empty,SubkatUP,RectDom2,T2,CPbesetzung1,Err3)
-->
{inklusionsHorizont(CB1,CB2),isSubjacencyBarrier(c,1,CB2,CB3),ecpAdjust(spec,CB3,CB4),nextBinding(obj,CB4,CB5)},
spur,
{setSpecCP(empty,CPbesetzung1,CPbesetzung2)},
c1(CB5,empty,SubkatUP,RectDom1,T1,CPbesetzung2,Err1),
{closeRectDom(RectDom1,RectDom2,Err2)},
{tree('CP','e',T1,T2)},
{mergeErrorStats(Err1,Err2,Err3)}.


%Entweder Subjekt oder Objekt an Spec-C'-Stelle
%Subjekte können keine Anaphern sein, deshalb die extra Zeile
c2(1,CB1,empty,SubkatUP,RectDom3,T3,CPbesetzung1,Err3)
-->
{MovedConstituent = subj; MovedConstituent = obj; MovedConstituent = longway},
n2(MP,1,_,dUMMY_NOT_FINAL,ART,T1),
{noAnaphoricSubject(MovedConstituent,ART)},
{inklusionsHorizont(CB1,CB2), openChain(MovedConstituent,ART,MP,CB2,CB3)},
{setSpecCP(ART,CPbesetzung1,CPbesetzung2)},
c1(CB3,empty,SubkatUP,RectDom1,T2,CPbesetzung2,Err1),
{newOmega(MP,ART,RectDom1,RectDom2), closeRectDom(RectDom2,RectDom3,Err2)},
{tree('CP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3)}.


%Präpositionalphrase in Spec-C'-Position
c2(1,CB1,empty,SubkatUP,RectDom2,T3,CPbesetzung1,Err3)
-->
%{MovedConstituent = subj; MovedConstituent = obj; MovedConstituent = longway},
%statt obj: MovedConstituent, um auch freeadjunct besetzen zu können.
p2(MP,_,T1),
{inklusionsHorizont(CB1,CB2), openChain(obj,pp,MP,CB2,CB3)},
{setSpecCP(pp,CPbesetzung1,CPbesetzung2)},
c1(CB3,empty,SubkatUP,RectDom1,T2,CPbesetzung2,Err1),
{closeRectDom(RectDom1,RectDom2,Err2)},
{tree('CP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3)}.





%%%%%%%%%%


c1(CB1,empty,SubkatUP,RectDom2,T3,CPbesetzung1,Err)
-->
{nichtDistinkt(CB1,CB2), ecpAdjust(comp,CB2,CB3), openChain(verb,irr,MP,CB3,CB4),exklusionsHorizont(CB4,CB5), nichtDistinkt(CB5,CB6), selegiert(CB6,CB7)},
{setC0(verb,CPbesetzung1,CPbesetzung2), erfuelltSatzartVorgabe(CPbesetzung2)},
c0(MP,SubkatDOWN,T1),
i2(1,CB7,SubkatDOWN,SubkatUP,RectDom1,T2,keine_u_verb_rektion,Err),
{newRho(RectDom1,RectDom2)},
{tree('C`',T1,T2,T3)}.


%"erfuelltSatzartVorgabe" überprüft die Besetzung der beiden CP-Positionen
c1(CB1,SubkatDOWN,SubkatUP,RectDom,T2,CPbesetzung1,Err)
-->
{exklusionsHorizont(CB1,CB2), distinkt(CB2,CB3), selegiert(CB3,CB4)},
{setC0(c0,CPbesetzung1,CPbesetzung2), erfuelltSatzartVorgabe(CPbesetzung2)},
c0,
i2(1,CB4,SubkatDOWN,SubkatUP,RectDom,T1,keine_u_verb_rektion,Err),
{tree('C`','C',T1,T2)}.




%in sätzen wie z.B. "was maria gesehen hat"
%~~~~~~~~~~~~~~~~~~~~
c1(CB1,SubkatDOWN,SubkatUP,RectDom,T2,CPbesetzung1,Err)
-->
{forciere_C0_unbesetzt(CB1,CPbesetzung1)},
{exklusionsHorizont(CB1,CB2), nichtDistinkt(CB2,CB3), selegiert(CB3,CB4)},
{setC0(empty,CPbesetzung1,CPbesetzung2), erfuelltSatzartVorgabe(CPbesetzung2)},
i2(1,CB4,SubkatDOWN,SubkatUP,RectDom,T1,keine_u_verb_rektion,Err),
{tree('C`','e',T1,T2)}.
%~~~~~~~~~~~~~~~~~~~~~~~~


%%%
%Typ-0-Adjunktion
c0(MP,Subkat,T2)
-->
i0(MP,Subkat,T1),
{tree_typ0adjunktion('C',T1,T2)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   FLEXION
%
% Komponenten i2-Funktor: Segmentnr. Adjunktion, Kettenbündel, Subkategorisierungsliste DOWN, Subkategorisierungsliste UP, Rektionsdomäne, Baum, I0-Head besetzt/Flexion vorhanden, Fehlerstatus
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Subjekt bewegt
i2(LO,CB1,SubkatDOWN,SubkatUP2,RectDom2,T2,keine_u_verb_rektion,Err4)
-->
{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(i,LO,CB2,CB3), ecpAdjust(spec,CB3,CB4), closeChain(subj,CB4,CB5,ART,MP)},
spur,
i1(CB5,SubkatDOWN,SubkatUP1,RectDom1,T1,flexion_present,Err1),
{kongruenz(subj,ART,MP,SubkatUP1,SubkatUP2,Err2)},
{closeRectDom(RectDom1,RectDom2,Err3)},
{tree('IP','e',T1,T2)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.


%Subjekt In-Place
i2(LO,CB1,SubkatDOWN,SubkatUP2,RectDom3,T3,keine_u_verb_rektion,Err4)
-->
{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(i,LO,CB2,CB3), exklusionsHorizont(CB3,CB4)},
{ART \== anaNP},
n2(MP,1,_,CB4,ART,T1),
i1(CB3,SubkatDOWN,SubkatUP1,RectDom1,T2,flexion_present,Err1),
{kongruenz(subj,np,MP,SubkatUP1,SubkatUP2,Err2)},
{newOmega(MP,ART,RectDom1,RectDom2), closeRectDom(RectDom2,RectDom3,Err3)},
{tree('IP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.



%Nebensätze
%ACHTUNG : 8. KOMPONENTE C2
i2(1,CB1,SubkatDOWN,SubkatUP1,RectDom,T3,keine_u_verb_rektion,Err4)
-->
{isSubjacencyBarrier(i,1,CB1,CB2), openChain(obj,cp,mp(_,_,_,irr,_,_,_,_,_,_),CB2,CB3), branchChainBundleCP(CB3,CB4,CB5)},
i2(2,CB4,SubkatDOWN,SubkatUP1,_,T1,keine_u_verb_rektion,Err1),
{dStrukturSchlingeLeer(SubkatUP2,Err2)},
c2(1,CB5,empty,SubkatUP2,RectDom,T2,_,Err3),
{tree('IP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.


%Adjunktion von pronomialen Objekten
%Dass ihn Peter gesehen hat
i2(LO,CB1,SubkatDOWN,SubkatUP,RectDom,T3,keine_u_verb_rektion,Err)
-->
{adjunktion(LO,HI)},
{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(i,LO,CB2,CB3), openChain(obj,pron,MP,CB3,CB4)},
n2(MP,1,_,_,pron,T1),
i2(HI,CB4,SubkatDOWN,SubkatUP,RectDom,T2,keine_u_verb_rektion,Err),
{tree('IP',T1,T2,T3)}.


%Subjekt ist fremdregiert, da IP eine AcI-Ergänzung ist.
i2(LO,CB1,SubkatDOWN,SubkatUP,RectDom3,T3,u_verb_rektion(Kasus),Err3)
-->
{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(i,LO,CB2,CB3)},
{MP = mp(_,_,_,Kasus,_,_,_,_,_,_)},
n2(MP,1,_,_,ART,T1),
i1(CB3,SubkatDOWN,SubkatUP,RectDom1,T2,no_IP_flexion,Err1),
{newOmega(MP,ART,RectDom1,RectDom2), closeRectDom(RectDom2,RectDom3,Err2)},
{tree('IP',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3)}.


%PRO aus der Kontrolltheorie
%i2(LO,CB1,SubkatDOWN,SubkatUP2,RectDom2,T3)
%-->
%{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(i,LO,CB2,CB3)},
%pro,
%i1(CB3,SubkatDOWN,SubkatUP1,RectDom1,T2),
%{kongruenz(subj,proKT,SubkatUP1,SubkatUP2)},
%{closeRectDom(RectDom1,RectDom2)},
%{tree('IP','PRO',T2,T3)}.




i1(CB1,empty,SubkatUP,RectDom2,T3,flexion_present,Err)
-->
{nichtDistinkt(CB1,CB2), ecpAdjust(comp,CB2,CB3), openChain(verb,irr,MP,CB3,CB4), exklusionsHorizont(CB4,CB5), nichtDistinkt(CB5,CB6), selegiert(CB6,CB7)},
v2(1,CB7,SubkatDOWN,SubkatUP,RectDom1,T1,_,Err),
i0(MP,SubkatDOWN,T2),
{newRho(RectDom1,RectDom2)},
{tree('I`',T1,T2,T3)}.


i1(CB1,SubkatDOWN,SubkatUP,RectDom,T2,flexion_present,Err)
-->
{nichtDistinkt(CB1,CB2), ecpAdjust(comp,CB2,CB3), ecpAdjust(head,CB3,CB4), nextBinding(verb,CB4,CB5), exklusionsHorizont(CB5,CB6), nichtDistinkt(CB6,CB7), selegiert(CB7,CB8)},
v2(1,CB8,SubkatDOWN,SubkatUP,RectDom,T1,_,Err),
spur,
{tree('I`',T1,'e',T2)}.


%Spezialfall: IP, in der KEINE Elemente flektiert sind.
i1(CB1,SubkatDOWN,SubkatUP,RectDom,T2,no_IP_flexion,Err)
-->
{ecpAdjust(comp,CB1,CB2), exklusionsHorizont(CB2,CB3), distinkt(CB3,CB4), selegiert(CB4,CB5)},
v2(1,CB5,SubkatDOWN,SubkatUP,RectDom,T1,_,Err),
spur,
{tree('I`',T1,'e',T2)}.



%%%
%Typ-0-Adjunktion
i0(MP,Subkat,T)
-->
v0(MP,PreSubkat),
{generateSubkat(MP,PreSubkat,Subkat)},
{flexion(MP)},
{tree_typ0adjunktion('I','V',T)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   VERBALPHRASEN
%
% Komponenten v2-Funktor: Segmentnr. Adjunktion, Kettenbündel, Subkategorisierungsliste DOWN, Subkategorisierungsliste UP, Rektionsdomäne, Baum, Workaround unnötiges Scrambling, Fehlerstatus
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%% Projektionen Typ 2

%V2 ohne Mucken
%AllowARGmovement durchgereicht!
v2(LO,CB1,SubkatDOWN,SubkatUP,RectDom2,T2,AllowARGmovement,Err3)
-->
{inklusionsHorizont(CB1,CB2), isSubjacencyBarrier(v,LO,CB2,CB3)},
v1(CB3,SubkatDOWN,SubkatUP,RectDom1,T1,AllowARGmovement,Err1),
{closeRectDom(RectDom1,RectDom2,Err2)},
{tree('VP',T1,T2)},
{mergeErrorStats(Err1,Err2,Err3)}.


%%Adjunktion eines Verbs in-Place/fehlt
v2(LO,CB1,SubkatDOWN,SubkatUP2,RectDom,T2,_,Err)
-->
{LO == 1},
{adjunktion(LO,HI)},
{isSubjacencyBarrier(v,LO,CB1,CB2), closeChain(verb,CB2,CB3,irr,_), inheritChainBundle(CB3,CB4)}, %nichtSelegiert(CB4,CB5)},
v2(HI,CB4,empty,SubkatUP1,RectDom,T1,_,Err),
spur,
{mergeSubkats(SubkatUP1,SubkatDOWN,SubkatUP2)},
{verbKombination(SubkatUP1,SubkatDOWN)},
{tree('VP',T1,'e',T2)}.


%Subkategorien dieses Verbs überspringen...es hat keine Flexion
v2(LO,CB1,SubkatDOWN,SubkatUP,RectDom,T2,_,Err)
-->
{LO =< 2},
{adjunktion(LO,HI)},
{isSubjacencyBarrier(v,LO,CB1,CB2)},
v2(HI,CB2,SubkatDOWN,SubkatUP,RectDom,T1,_,Err),
v0(MP,PreSubkat),
{no_flexion(MP)},
{verbKombination(SubkatUP,subkatChan(MP,_))},
{tree('VP',T1,'V',T2)}.


%NP-Objekt, durch Scrambling bewegt
v2(LO,CB1,SubkatDOWN,SubkatUP1,RectDom,T3,_,Err)
-->
{adjunktion(LO,HI)},
n2(MP,1,_,CB5,ART,T1),
{isSubjacencyBarrier(v,LO,CB1,CB2),exklusionsHorizont(CB2,CB3),selegiert(CB3,CB5), openChain(obj,ART,MP,CB2,CB4)},
v2(HI,CB4,SubkatDOWN,SubkatUP1,RectDom,T2,disallowARGmovement,Err),
{tree('VP',T1,T2,T3)}.

%PP-Objekt, durch Scrambling bewegt
v2(LO,CB1,SubkatDOWN,SubkatUP1,RectDom,T3,_,Err)
-->
{adjunktion(LO,HI)},
p2(MP,_,T1),
{isSubjacencyBarrier(v,LO,CB1,CB2), openChain(obj,pp,MP,CB2,CB3)},
v2(HI,CB3,SubkatDOWN,SubkatUP1,RectDom,T2,disallowARGmovement,Err),
{tree('VP',T1,T2,T3)}.



%%Freie Adjunkte anderer Kategorien
v2(LO,CB1,SubkatDOWN,SubkatUP,RectDom,T3,_,Err)
-->
{adjunktion(LO,HI)},
{isSubjacencyBarrier(v,LO,CB1,CB2)},
adv2(_,T1),
v2(HI,CB2,SubkatDOWN,SubkatUP,RectDom,T2,allowARGmovement,Err),
{tree('VP',T1,T2,T3)}.


v2(LO,CB1,SubkatDOWN,SubkatUP,RectDom,T3,_,Err)
-->
{adjunktion(LO,HI)},
{isSubjacencyBarrier(v,LO,CB1,CB2)},
a2(_,_,T1),
v2(HI,CB2,SubkatDOWN,SubkatUP,RectDom,T2,allowARGmovement,Err),
{tree('VP',T1,T2,T3)}.


v2(LO,CB1,SubkatDOWN,SubkatUP,RectDom,T3,_,Err)
-->
{adjunktion(LO,HI)},
{isSubjacencyBarrier(v,LO,CB1,CB2)},
p2(_,_,T1),
v2(HI,CB2,SubkatDOWN,SubkatUP,RectDom,T2,allowARGmovement,Err),
{tree('VP',T1,T2,T3)}.



%%%%%%% Projektionen Typ 1


%Verb in-Place/fehlt
%distinkt schenken wir uns, weil weiter unten UNMÖGLICH noch Argumente kommen

v1(CB,empty,SubkatUP,RectDom2,T,_,[ok])
-->
{terminateChainBundle(CB)},
v0(MP,PreSubkat),
{generateSubkat(MP,PreSubkat,SubkatUP)},
{no_flexion(MP)},
{initRectDom(RectDom1), newRho(RectDom1,RectDom2)},
{tree('V`','V',T)}.


%die eigentliche D-Struktur-Schlinge
v1(CB1,Subkat,Subkat,RectDom,T,_,[ok])
-->
{ecpAdjust(head,CB1,CB2), closeChain(verb,CB2,CB3,_,_), terminateChainBundle(CB3)},
spur,
{initRectDom(RectDom)},
{tree('V`','e',T)}.


%Objekt in-Place für NPs
v1(CB1,SubkatDOWN,SubkatUP2,RectDom2,T3,_,Err3)
-->
n2(MP,1,_,CB2,ART,T1),
{exklusionsHorizont(CB1,CB2), freeObject2Chain(CB1,CB3)},
v1(CB3,SubkatDOWN,SubkatUP1,RectDom1,T2,_,Err1),
{kongruenz(obj,ART,MP,SubkatUP1,SubkatUP2,Err2)},
{newAlpha(MP,ART,RectDom1,RectDom2)},
{tree('V`',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3)}.


%Objekt in-Place für PPs
v1(CB1,SubkatDOWN,SubkatUP2,RectDom2,T3,_,Err3)
-->
p2(MP,_,T1),
{freeObject2Chain(CB1,CB2)},
v1(CB2,SubkatDOWN,SubkatUP1,RectDom1,T2,_,Err1),
{kongruenz(obj,pp,MP,SubkatUP1,SubkatUP2,Err2)},
{newAlpha(MP,pp,RectDom1,RectDom2)},
{tree('V`',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3)}.



%Dies ist das einzige Segment, in welchem durch das Ausschreiben der 6. Komponente (allowARGmovement) überprüft wird, ob ein ARGUMENT unnötig bewegt wurde
v1(CB1,SubkatDOWN,SubkatUP2,RectDom2,T2,allowARGmovement,Err3)
-->
{ecpAdjust(srByVerb,CB1,CB2), closeChain(obj,CB2,CB3,ART,MP)},
spur,
v1(CB3,SubkatDOWN,SubkatUP1,RectDom1,T1,_,Err1),
{kongruenz(obj,ART,MP,SubkatUP1,SubkatUP2,Err2)},
{newAlpha(MP,ART,RectDom1,RectDom2)},
{tree('V`','e',T1,T2)},
{mergeErrorStats(Err1,Err2,Err3)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% Ergänzungen

%CP-Ergänzung in-Place
%ACHTUNG: 8. KOMPONENTE VON C2 DEFINIEREN
v1(CB1,SubkatDOWN,SubkatUP2,RectDom,T3,_,Err4)
-->
{freeObject2Chain(CB1,CB2), branchChainBundleCP(CB2,CB3,CB4)},
{dStrukturSchlingeLeer(SubkatUP3,Err1)},
c2(1,CB4,empty,SubkatUP3,RectDom,T1,_,Err1),
v1(CB3,SubkatDOWN,SubkatUP1,_,T2,_,Err2),
{kongruenz(obj,cp,mp(_,_,_,irr,_,_,_,_,_,_),SubkatUP1,SubkatUP2,Err3)},
{tree('V`',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.


%Infinitivergänzung zu AcI-Verben
v1(CB1,SubkatDOWN,SubkatUP2,RectDom1,T3,_,Err4)
-->
{branchChainBundleIP(CB1,CB2,CB3), infinitivo(SubkatUP3)},
{allAlphasBound(RectDom2)},
i2(1,CB3,empty,SubkatUP3,RectDom2,T1,u_verb_rektion(akk),Err1),
{freeObject2Chain(CB2,CB4)},
v1(CB4,SubkatDOWN,SubkatUP1,RectDom1,T2,_,Err2),
{kongruenz(obj,ip,mp(_,_,_,irr,_,_,_,_,_,_),SubkatUP1,SubkatUP2,Err3)},
{tree('V`',T1,T2,T3)},
{mergeErrorStats(Err1,Err2,Err3,Err4)}.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   NOMINALPHRASEN
%
% Komponenten n2-Funktor: Morphologisches Paket, Koordinierende Konjunktion, Segmentnr. Adjunktion, Kettenbündel, Baum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%W-Phrasen
n2(MP,1,noConjunction,_,ART,'W-NP')
-->
wwort(MP,ART).

%anaphorische NPs
n2(MP,1,noConjunction,_,ART,'ANAPH.-NP')
-->
ana(MP,ART).


%pronomiale NPs
n2(MP,1,noConjunction,_,pron,'PRON.-NP')
-->
pron(MP).


n2(MP1,LO,noConjunction,Bi1,np,T2)
-->
%{isSubjacencyBarrier(n,LO,Bi1,Bi2)},
n1(MP1,Bi2,T1),
{tree('NP',T1,T2)}.


n2(MP1,LO,noConjunction,Bi1,np,T2)
-->
%{isSubjacencyBarrier(n,LO,Bi1,Bi2)},
det(MP1),
n1(MP1,Bi2,T1),
{tree('NP','Det',T1,T2)}.


n2(MP1,LO,noConjunction,Bi1,np,T2)
-->
%{isSubjacencyBarrier(n,LO,Bi1,Bi2)},
pospron(MP1),
n1(MP1,Bi2,T1),
{tree('NP','PosPron',T1,T2)}.


% n2(MP1)
% -->
% a2(MP2),
% n2(MP1).


n2(MP1,LO,noConjunction,Bi1,np,T2)
-->
{adjunktion(LO,HI)},
%{isSubjacencyBarrier(n,LO,Bi1,Bi2)},
n0(MP1),
n2(MP1,HI,noConjunction,Bi2,np,T1),
{tree('NP','N',T1,T2)}.


n1(MP,_,T)
-->
n0(MP),
{tree('N`','N',T)}.


n1(MP1,_,T3)
-->
a2(MP2,_,T1),
n1(MP1,_,T2),
{teilkongruenz3(MP1,MP2)},
{tree('N`',T1,T2,T3)}.


n1(MP1,_,T2)
-->
n0(MP1),
p2(MP2,_,T1),
{tree('N`','N',T1,T2)}.


%Relativsätze
n1(MP1,_,T2)
-->
n0(MP1),
{initChainBundle(CB1)},
c2(1,CB1,empty,SubkatUP,RectDom,T1,cpbesetzung(_,_,relativsatz(MP1)),Err),
{dStrukturSchlingeLeer(SubkatUP,Err)},
{allAlphasBound(RectDom)},
{tree('N`','N',T1,T2)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   PRÄPOSITIONALPHRASEN
%
% Komponenten p2-Funktor: Morphologisches Paket, Koordinierende Konjunktion, Baum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


p2(MP1,noConjunction,T2)
-->
p1(MP1,T1),
{tree('PP',T1,T2)}.


p1(MP1,T2)
-->
%{initChainBundle(ChainBundle1)},
p0(MP1),
n2(MP2,1,_,dUMMY_NOT_FINAL,_,T1),
{teilkongruenz1(MP1,MP2)},
{tree('P`','P',T1,T2)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   ADJEKTIVPHRASEN
%
% Komponenten a2-Funktor: Morphologisches Paket, Koordinierende Konjunktion, Baum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


a2(MP,noConjunction,T2)
-->
part,
a1(MP,T1),
{tree('AP','Part',T1,T2)}.


a2(MP,noConjunction,T2)
-->
a1(MP,T1),
{tree('AP',T1,T2)}.


a1(MP,T)
-->
a0(MP),
{tree('A`','A',T)}.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   ADVERBIALPHRASEN
%
% Komponenten adv2-Funktor: Morphologisches Paket, Koordinierende Konjunktion, Baum
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



adv2(noConjunction,T2)
-->
adv1(T1),
{tree('AdvP',T1,T2)}.


adv1(T)
-->
adv0,
{tree('Adv`','Adv',T)}.



spur --> [].
%pro  --> [].







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   KONJUNKTIONEN
%
% Komponenten des Funktors: INTERFACE ENTSPRECHEND DEM INTEFACE DER KOORDINIERTEN KATEGORIEN
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


n2(MP3,1,conjunction,_,ART3,T3)
-->
n2(MP1,1,noConjunction,_,ART1,T1),
koord0,
n2(MP2,1,noConjunction,_,ART2,T2),
{mergeARTkonjunktion(ART1,ART2,ART3)},
{pluralizeMP(MP1,MP2,MP3)},
{tree('NP',T1,'Koord',T2,T3)}.


p2(MP1,conjunction,T3)
-->
p2(MP1,noConjunction,T1),
koord0,
p2(MP2,noConjunction,T2),
{teilkongruenz1(MP1,MP2)},
{tree('PP',T1,'Koord',T2,T3)}.


a2(MP1,conjunction,T3)
-->
a2(MP1,noConjunction,T1),
koord0,
a2(MP2,noConjunction,T2),
{teilkongruenz4(MP1,MP2)},
{tree('AP',T1,'Koord',T2,T3)}.


adv2(conjunction,T3)
-->
adv2(noConjunction,T1),
koord0,
adv2(noConjunction,T2),
{tree('AdvP',T1,'Koord',T2,T3)}.









%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% DEBUG


xxx :- true.
yyy :- true.

xxx(_).
yyy(_).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Konjunktionen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


mergeARTkonjunktion(ap,ap,ap).
mergeARTkonjunktion(pp,pp,pp).
mergeARTkonjunktion(cp,cp,cp).
mergeARTkonjunktion(np,np,np).
mergeARTkonjunktion(pron,np,np).
mergeARTkonjunktion(np,pron,np).
mergeARTkonjunktion(pron,pron,pron).
mergeARTkonjunktion(wnp,wnp,wnp).
mergeARTkonjunktion(wpp,wpp,wpp).

%vermutlich ungrammatisch:
%*mergeARTkonjunktion(anaNP,np,anaNP).
%*mergeARTkonjunktion(np,anaNP,anaNP).


%Sofern Kongruenz bezüglich Kasus herrscht, wird der Numerus auf Plural gesetzt.
pluralizeMP(mp(_,_,_,Kasus,_,_,_,_,_,_),mp(_,_,_,Kasus,_,_,_,_,_,_),mp(_,pl,_,Kasus,_,_,_,_,_,_)).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ketten
%%%%%%%%%%%%%%%%%%%%%%%%%%%%


initChainBundle([empty,empty,empty,empty,empty]).

openChain(verb,      _, MP, [empty,A,B,C,E], [c(irr,MP,nonIE,nonIe,nichtSelegiert,miniBarrSchutz,0,0),A,B,C,E]).
openChain(subj,    ART, MP, [A,empty,B,C,E], [A,c(ART,MP,nonIE,nonIe,nichtSelegiert,pre,0,0),B,C,E]).
openChain(obj,     ART, MP, [A,B,empty,C,E], [A,B,c(ART,MP,nonIE,nonIe,nichtSelegiert,pre,0,0),C,E]).
openChain(obj,     ART, MP, [A,B,C,empty,E], [A,B,C,c(ART,MP,nonIE,nonIe,nichtSelegiert,pre,0,0),E]).
openChain(longway, ART, MP, [A,B,C,D,empty], [A,B,C,D,c(ART,MP,nonIE,nonIe,nichtSelegiert,pre,0,0)]).


exklusionsHorizont([],[]).
exklusionsHorizont([c(ART,MP,_,_,Selektion,MiniBarr,N,M)|REST1],[c(ART,MP,exkludiert,nonIE,Selektion,MiniBarr,N,M)|REST2]) :- exklusionsHorizont(REST1,REST2).
exklusionsHorizont([empty|REST1],[empty|REST2]) :- exklusionsHorizont(REST1,REST2).
exklusionsHorizont([done|REST1],[done|REST2]) :- exklusionsHorizont(REST1,REST2).


inklusionsHorizont([],[]).
inklusionsHorizont([c(ART,MP,IEstatReg,_,Selektion,MiniBarr,N,M)|REST1],[c(ART,MP,IEstatReg,inkludiert,Selektion,MiniBarr,N,M)|REST2]) :- inklusionsHorizont(REST1,REST2).
inklusionsHorizont([empty|REST1],[empty|REST2]) :- inklusionsHorizont(REST1,REST2).
inklusionsHorizont([done|REST1],[done|REST2]) :- inklusionsHorizont(REST1,REST2).


%hier den MiniBarrSchutz nicht aufheben, die Kette geht ja schließlich noch weiter
nextBinding(verb, [c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),A,B,C,E], [c(ART,MP,nonIE,nonIE,nichtSelegiert,miniBarrSchutz,0,0),A,B,C,E]) :- SubjazenzBknoten =< 1, BarrZahl == 0.
nextBinding(obj,  [A,B,c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),C,E], [A,B,c(ART,MP,nonIE,nonIE,nichtSelegiert,pre,0,0),C,E]) :- SubjazenzBknoten =< 1, BarrZahl == 0.
nextBinding(obj,  [A,B,C,c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),E], [A,B,C,c(ART,MP,nonIE,nonIE,nichtSelegiert,pre,0,0),E]) :- SubjazenzBknoten =< 1, BarrZahl == 0.

%Noch offene Argumente sollen vererbt werden an den Ketten-Bundle des darunter liegenden Verbs
inheritChainBundle([empty,empty,A,B,E],[empty,empty,A,B,E]).

%Wenn das 1. Objekt nicht bewegt wurde, so müssen wir doch der Kette für ein bewegtes 2. Objekt die Möglichkeit einräumen, geschlossen zu werden.  
freeObject2Chain([A,B,empty,C,E], [A,B,done,C,E]).
freeObject2Chain([A,B,done,C,E],  [A,B,done,C,E]).

%Hier ist die Reihenfolge EXTREM wichtig!!!!!!
%Zuerst das erste Argument abbauen, erst dann dürfen wir das zweite antasten
%Das zweite ARG kann nur dann abgebaut werden, wenn es überhaupt ein erstes gab!
closeChain(verb, [c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),A,B1,C1,E],   [empty,A,B2,C2,E], ART, MP) :- miniBarrSchutzAufheben(B1,B2), miniBarrSchutzAufheben(C1,C2), SubjazenzBknoten =< 1, BarrZahl == 0.
closeChain(subj, [A,c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),B,C,E],     [A,empty,B,C,E], ART, MP) :- SubjazenzBknoten =< 1, BarrZahl == 0.
closeChain(obj,  [A,B,c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),C,E],     [A,B,done,C,E], ART, MP) :- SubjazenzBknoten =< 1, BarrZahl == 0.
closeChain(obj,  [A,B,done,c(ART,MP,_,_,_,_,SubjazenzBknoten,BarrZahl),E],  [A,B,done,empty,E], ART, MP) :- SubjazenzBknoten =< 1, BarrZahl == 0.


terminateChainBundle([empty,empty,empty,empty,empty]).
terminateChainBundle([empty,empty,done,empty,empty]).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ketten verzweigen, bei eingebetteten Nebensätzen (CP) oder IP-Ergänzungen (bei AcI-Verben) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Sinn: Eine NP (Pronomen, Anapher), die in Spec-C' steht, könnte auch aus dem Nebensatz herausbewegt worden sein
%wir sparen uns zwei extra-Aufrufe bezüglich Exklusion und Selektion

%Sie könnte das herausbewegte Subjekt sein????????
%Dann auch die Spur-Informationen unter C2 abändern!!!!!!!!!


%Sie könnte eines von zwei möglichen Argumenten sein
branchChainBundleCP([A,B,C,D,c(ART,MP,_,IEstatBeta,_,_,SubjazenzBknoten,BarrZahl)],[A,B,C,D,empty],[empty,empty,c(ART,MP,exkludiert,IEstatBeta,selegiert,keinMiniBarrSchutz,SubjazenzBknoten,BarrZahl),empty,empty]).
branchChainBundleCP([A,B,C,D,c(ART,MP,_,IEstatBeta,_,_,SubjazenzBknoten,BarrZahl)],[A,B,C,D,empty],[empty,empty,empty,c(ART,MP,exkludiert,IEstatBeta,selegiert,keinMiniBarrSchutz,SubjazenzBknoten,BarrZahl),empty]).


%Es gibt ja auch die Möglichkeit, dass er gar kein herausbewegtes Argument GIBT!
branchChainBundleCP([A,B,C,D,empty],[A,B,C,D,empty],[empty,empty,empty,empty,empty]).


%Für IPs gilt ein Sonderfall: da der Head nicht besetzt ist, kann die IP auch unmöglich eine Minimalitätsbarriere errichten
branchChainBundleIP([A,B,C,D,c(ART,MP,_,IEstatBeta,_,_,SubjazenzBknoten,BarrZahl)],[A,B,C,D,empty],[empty,empty,c(ART,MP,exkludiert,IEstatBeta,selegiert,miniBarrSchutz,SubjazenzBknoten,BarrZahl),empty,empty]).
branchChainBundleIP([A,B,C,D,c(ART,MP,_,IEstatBeta,_,_,SubjazenzBknoten,BarrZahl)],[A,B,C,D,empty],[empty,empty,empty,c(ART,MP,exkludiert,IEstatBeta,selegiert,miniBarrSchutz,SubjazenzBknoten,BarrZahl),empty]).
branchChainBundleIP([A,B,C,D,empty],[A,B,C,D,empty],[empty,empty,empty,empty,empty]).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Subjazenz
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Barrierenzähler je nach Sigma und nach IE-Status inkrementiert
%Es zählt nur die EXKLUSION des vorherigen Kettenelements
isSubjacencyBarrier(_,1,[],[]).
isSubjacencyBarrier(SigmaCategory,1,[empty|REST1],[empty|REST2]) :- isSubjacencyBarrier(SigmaCategory,1,REST1,REST2).
isSubjacencyBarrier(SigmaCategory,1,[done|REST1],[done|REST2]) :- isSubjacencyBarrier(SigmaCategory,1,REST1,REST2).
isSubjacencyBarrier(SigmaCategory,1,[c(ART,MP,IEstatReg,IEstatBeta,Selektion,MiniBarr,N1,M)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,Selektion,MiniBarr,N2,M)|REST2]) :- singleChanISB(SigmaCategory,IEstatReg,N1,N2), isSubjacencyBarrier(SigmaCategory,1,REST1,REST2).
isSubjacencyBarrier(_,SegmentNr, SUBKAT, SUBKAT) :- SegmentNr > 1.

%Einzelkanalbehandlung
singleChanISB(n,exkludiert,Count1,Count2) :- Count2 is Count1 + 1, !.
singleChanISB(i,exkludiert,Count1,Count2) :- Count2 is Count1 + 1, !.
singleChanISB(_,_,Count1,Count1).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Empty Category Principle
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

distinkt([],[]).
distinkt([c(ART,MP,IEstatReg,IEstatBeta,Selektion,pre,N,M)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,Selektion,keinMiniBarrSchutz,N,M)|REST2]) :- distinkt(REST1,REST2), !.
distinkt([Chan|REST1],[Chan|REST2]) :- distinkt(REST1,REST2).

nichtDistinkt([],[]).
nichtDistinkt([c(ART,MP,IEstatReg,IEstatBeta,Selektion,pre,N,M)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,Selektion,miniBarrSchutz,N,M)|REST2]) :- nichtDistinkt(REST1,REST2), !.
nichtDistinkt([Chan|REST1],[Chan|REST2]) :- nichtDistinkt(REST1,REST2).

selegiert([],[]).
selegiert([c(ART,MP,IEstatReg,IEstatBeta,_,MiniBarr,N,M)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,selegiert,MiniBarr,N,M)|REST2]) :- selegiert(REST1,REST2), !.
selegiert([Chan|REST1],[Chan|REST2]) :- selegiert(REST1,REST2).

nichtSelegiert([],[]).
nichtSelegiert([c(ART,MP,IEstatReg,IEstatBeta,_,MiniBarr,N,M)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,nichtSelegiert,MiniBarr,N,M)|REST2]) :- nichtSelegiert(REST1,REST2), !.
nichtSelegiert([Chan|REST1],[Chan|REST2]) :- nichtSelegiert(REST1,REST2).

%Wenn eine Verbkette endet, und die Objektkette(n) noch nicht, so ist eine Minimalitätsbarriere möglich
miniBarrSchutzAufheben(c(ART,MP,IEstatReg,IEstatBeta,Selektion,miniBarrSchutz,N,M),c(ART,MP,IEstatReg,IEstatBeta,Selektion,keinMiniBarrSchutz,N,M)) :- !.
miniBarrSchutzAufheben(Chan,Chan).


%SelfPosition ist ein Flag, dass entweder comp, spec, head, oder srByVerb ist. Letzteres kommt dann zum Einsatz, wenn ein Kettenelement nicht von seinem Vorgänger, sondern direkt vom Verb strikt regiert werden kann! 
ecpAdjust(_,[],[]).
ecpAdjust(SelfPosition,[empty|REST1],[empty|REST2]) :- ecpAdjust(SelfPosition,REST1,REST2).
ecpAdjust(SelfPosition,[done|REST1],[done|REST2]) :- ecpAdjust(SelfPosition,REST1,REST2).
ecpAdjust(SelfPosition,[c(ART,MP,IEstatReg,IEstatBeta,Selektion,MiniBarrSchutz,SubjazenzBknoten,SigmasCount1)|REST1],[c(ART,MP,IEstatReg,IEstatBeta,Selektion,MiniBarrSchutz,SubjazenzBknoten,SigmasCount2)|REST2]) :- singleChanECPA(SelfPosition,IEstatReg,IEstatBeta,Selektion,MiniBarrSchutz,SigmasCount1,SigmasCount2), ecpAdjust(SelfPosition,REST1,REST2).

%singleChanECPA(_,_,_,_,pre,X,X) :- !.
singleChanECPA(comp,exkludiert,inkludiert,nichtSelegiert,_,X,Y) :- Y is X + 1, !.
singleChanECPA(comp,exkludiert,inkludiert,selegiert,keinMiniBarrSchutz,X,Y) :- Y is X + 1, !.
singleChanECPA(spec,exkludiert,inkludiert,nichtSelegiert,_,X,Y) :- Y is X + 1, !.
singleChanECPA(head,exkludiert,inkludiert,nichtSelegiert,_,X,Y) :- Y is X + 1, !.
singleChanECPA(_,_,_,_,_,X,X).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Kongruenz
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%bekommt als Argument die Liste der subkategorisierten Argumente des Verbs
generateSubkat(
mp(Person,Numerus,Genus,Kasus,Komparation,Modus,Tempus,fini,Verbart,TempKombi),
PreSubkat1,
subkatChan(
   mp(Person,Numerus,Genus,Kasus,Komparation,Modus,Tempus,fini,Verbart,TempKombi),
   [subj(np,nom,Person,Numerus)|ObjectList]
   )
   )
:-
implicitSubkat(Verbart,PreSubkat1,PreSubkat2),
finalizeObjects_mo(PreSubkat2,ObjectList).


%handelt es sich um kein flektiertes Verb oder Passiv, so wird auch kein Subjekt gefordert
generateSubkat(
mp(Person,Numerus,Genus,Kasus,Komparation,Modus,Tempus,Finitheit,Verbart,TempKombi),
PreSubkat1,
subkatChan(
   mp(Person,Numerus,Genus,Kasus,Komparation,Modus,Tempus,Finitheit,Verbart,TempKombi),
   ObjectList
   )
   )
:-
Finitheit \== fini,
implicitSubkat(Verbart,PreSubkat1,PreSubkat2),
finalizeObjects_mo(PreSubkat2,ObjectList).


%Hier werden die nicht explizit im Lexikon angegebenen, aber durch die Verbart verlangten Ergänzungen dem Subkategorisierungsrahmen hinzugefügt
implicitSubkat(voll,S1,S1).
implicitSubkat(ha,S1,S1).
implicitSubkat(is,S1,S1).
implicitSubkat(modal,S1,S1).
implicitSubkat(modalit,S1,S1).
implicitSubkat(aci,S1,S2) :- append(S1,[obj(ip,irr,m)],S2).


%Aus den Subkategorisierungsinformationen erstellen wir die finale Subkategorisierungsliste, die zur Verifikation des Satzes verwendet wird.
finalizeObjects_mo([],[]).
finalizeObjects_mo([obj(ART,KASUS,m)|A],[obj(ART,KASUS)|B]) :- finalizeObjects_mo(A,B).
finalizeObjects_mo([obj(ART,KASUS,o)|A],[obj(ART,KASUS)|B]) :- finalizeObjects_mo(A,B).
finalizeObjects_mo([obj(_,_,o)|A],B) :- finalizeObjects_mo(A,B).




%fordert eine teilweise Kongruenz der Morphempakete
%1 Attribut
teilkongruenz1(mp(_,_,_,Kasus,_,_,_,_,_,_),mp(_,_,_,Kasus,_,_,_,_,_,_)).

%3 Attribute
teilkongruenz3(mp(_,Numerus,Genus,Kasus,_,_,_,_,_,_),mp(_,Numerus,Genus,Kasus,_,_,_,_,_,_)).

%4 Attribute
teilkongruenz4(mp(_,Numerus,Genus,Kasus,Komparation,_,_,_,_,_),mp(_,Numerus,Genus,Kasus,Komparation,_,_,_,_,_)).






%An der D-Struktur-Position von NPs (die in einer VP, oder an Spec-I' stehen), wird überprüft, ob die morphologischen Eigenschaften der NPs mit den Subkategorisierungsforderungen kongruent sind
%Spezialfall: PRO an Subjektstelle (Kontrolltheorie)
%kongruenz(subj,proKT,subkatChan(MP,ARGS),subkatChan(MP,ARGSreduced)) :- lastArg(ARGS, subj(proKT)), allbutlast(ARGS,ARGSreduced). 

%normale Fälle
kongruenz(subj,ART1,mp(Person1,Numerus,_,nom,_,_,_,_,_,_),subkatChan(MP,ARGS),subkatChan(MP,ARGSreduced),[ok]) :- lastArg(ARGS, subj(ART2,nom,Person2,Numerus)), artVereinbarkeit(ART1,ART2), personKongruenz(Person1,Person2), allbutlast(ARGS,ARGSreduced).
kongruenz(obj,ART1,mp(_,_,_,Kasus,_,_,_,_,_,_),subkatChan(MP,ARGS),subkatChan(MP,ARGSreduced),[ok]) :- lastArg(ARGS, obj(ART2,Kasus)), artVereinbarkeit(ART1,ART2), allbutlast(ARGS,ARGSreduced).


%statt "regulären" NPs können auch Pronomen/Anaphern/W-Worte uvm. anstelle von Verb-Argumenten stehen 
artVereinbarkeit(np,np).
artVereinbarkeit(pron,np).
artVereinbarkeit(anaNP,np).
artVereinbarkeit(wnp,np).
artVereinbarkeit(anaPP,pp).
artVereinbarkeit(pp,pp).
artVereinbarkeit(wpp,pp).
artVereinbarkeit(cp,cp).
artVereinbarkeit(ip,ip).


%Bei Nomen ist das Attribut "Person" nicht explizit im Lexikon angegeben ist, obwohl Person = 3 richtig wäre.
%D.h., das Attribut "Person" wird als "3. Person" angenommen, sofern es nicht explizit spezifiziert ist.
personKongruenz(P1,P2) :- P1 == 1, P2 == 1, !.
personKongruenz(P1,P2) :- P1 == 2, P2 == 2, !.
personKongruenz(P1,P2) :- P1 == 3, P2 == 3, !.
personKongruenz(P1,P2) :- P1 = 3, P2 == 3.

%sieht zwar eleganter aus, funktioniert aber nicht richtig!!!
%personKongruenz(P,3) :- var(P), !.
%personKongruenz(1,1) :- !.
%personKongruenz(2,2) :- !.
%personKongruenz(3,3) :- !.



%Gibt das letzte Element einer Liste zurück
lastArg([_,_,_,D],D).
lastArg([_,_,C],C).
lastArg([_,B],B).
lastArg([A],A).

%gibt eine Liste abzüglich ihres letzten Elements zurück
allbutlast([A,B,C,_],[A,B,C]).
allbutlast([A,B,_],[A,B]).
allbutlast([A,_],[A]).
allbutlast([_],[]).

%Wenn wir mehrere Verben in einem Satz haben, müssen wir die Subkategorisierungsinformationen an gegebener Stelle verschmelzen!
%Wir übernehmen die morphologischen Eigenschaften des höheren Verbs, da nur dies für das wiederum höhere Verb entscheidend ist.
mergeSubkats(subkatChan(MP1,[]),
             subkatChan(MP2,ARGS),
             subkatChan(MP2,ARGS)).
             
%Bei Kombination mehrerer Verben zu einem mehrteiligen Prädikat möchten die Verben jeweils ganz bestimmte andere Verbarten regieren.
verbKombination(subkatChan(mp(_,_,_,_,_,_,_,part2,voll,ha),_),subkatChan(mp(_,_,_,_,_,_,_,_,ha,_),_)).
verbKombination(subkatChan(mp(_,_,_,_,_,_,_,part2,aci,ha),_),subkatChan(mp(_,_,_,_,_,_,_,_,ha,_),_)).
verbKombination(subkatChan(mp(_,_,_,_,_,_,_,part2,voll,is),_),subkatChan(mp(_,_,_,_,_,_,_,_,is,_),_)).
verbKombination(subkatChan(mp(_,_,_,_,_,_,_,inf,voll,_),_),subkatChan(mp(_,_,_,_,_,_,_,_,modal,_),_)).
verbKombination(subkatChan(mp(_,_,_,_,_,_,_,zu_inf,voll,_),_),subkatChan(mp(_,_,_,_,_,_,_,_,modalit,_),_)).



%An der CP muss das eine Ende unserer D-Struktur-Schlinge leer sein
%Bestätigung des Fehlerstatus
dStrukturSchlingeLeer(subkatChan(_,[]),[ok]).


%Vorhandensein von Flexionsmerkmalen
%flexion(subkatChan(mp(_,_,_,_,_,_,_,fini,_,_),_)).
flexion(   mp(_,_,_,_,_,_,_,fini,_,_)).
no_flexion(mp(_,_,_,_,_,_,_,Finitheit,_,_)) :- Finitheit \== fini.


%Sonderfall: die ganze IP besitzt keine Flexion (z.B. wenn IP Ergänzung eines AcI-Verbs ist)
%Nur in diesem ganz speziellen Sonderfall erlauben wir, dass die Subjektposition mit PRO (Kontrolltheorie)/einem Akkusativus besetzt werden kann.
infinitivo(subkatChan(mp(_,_,_,_,_,_,_,inf,_,_),[])).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Adjunktion
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Adjunktion erzeugt verteilte Kategorien
adjunktion(LO,HI) :- HI is LO + 1.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Bindungs- und Kontrolltheorie
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

noAnaphoricSubject(subj,anaNP) :- !, fail.
noAnaphoricSubject(_,_).


initRectDom(rectDom(noAlpha,noRho,noOmega)).

%wir übergeben np, anaNP, pron als Argumente, damit die BT auch für bewegte Konstituenten funktioniert
newAlpha(MP,anaNP,rectDom(_,Rho,Omega),rectDom(alpha(MP),Rho,Omega)) :- !.

%Falls Spuren nicht von bewegter Anapher stammen, haben wir auch kein neues Alpha 
newAlpha(_,_,rectDom(Alpha,Rho,Omega),rectDom(Alpha,Rho,Omega)).


%noRho statt _ ??????
newRho(rectDom(Alpha,_,Omega),rectDom(Alpha,rho,Omega)).

newOmega(MP,np,rectDom(Alpha,Rho,_),rectDom(Alpha,Rho,omega(MP))).
newOmega(MP,pron,rectDom(Alpha,Rho,_),rectDom(Alpha,Rho,omega(MP))).
newOmega(MP,wnp,rectDom(Alpha,Rho,_),rectDom(Alpha,Rho,omega(MP))).
newOmega(_,cp,rectDom(Alpha,Rho,_),rectDom(Alpha,Rho,omega(cp))).

%Grenze der Rektionsdomäne mit erfolgreichem Atezedens <--> Anapher - Numerus-Kongruenz-Test 
closeRectDom(rectDom(alpha(mp(_,Numerus,_,_,_,_,_,_,_,_) ),rho,omega(mp(_,Numerus,_,_,_,_,_,_,_,_)) ),rectDom(noAlpha,noRho,noOmega), [ok]) :- !.

%Grenze der Rektionsdomäne noch nicht erreicht, trotzdem versuchen wir es.
%1. Variante, die strenger ist:
%closeRectDom(rectDom(Alpha,_,_),rectDom(Alpha,noRho,noOmega), [ok]).


%Wenn Anapher noch nicht erreicht, behalten wir Rho und Omega in keinem Fall bei -- damit eine Bindung tatsächlich nur nach oben funktioniert!!
closeRectDom(rectDom(noAlpha,_,_),rectDom(noAlpha,noRho,noOmega), [ok]) :- !.
closeRectDom(rectDom(Alpha,Rho,Omega),rectDom(Alpha,Rho,Omega), [ok]).

allAlphasBound(rectDom(noAlpha,_,_)) :- !.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X-Bar-Struktur herstellen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Erleichtert auch das Debuggen
tree(Root,Tl,Tr,T0) :- concat_atom([Root,Tl,Tr,']'],' ',Teil1), atom_concat('[',Teil1,T0).
tree(Root,Ts,T0) :- concat_atom([Root,Ts],' ',Teil1), atom_concat(Teil1,']',Teil2) , atom_concat('[',Teil2,T0).
tree(Root,Tl,KOORD,Tr,T0) :- concat_atom([Root,Tl,KOORD,Tr,']'],' ',Teil1), atom_concat('[',Teil1,T0).

tree_typ0adjunktion(Root,Ts,T0) :- concat_atom([Root,Ts],'+',T0).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Satzarten überprüfen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%Wenn C0 unbesetzt ist, dann muss in Spec-C' ein W-Wort stehen
forciere_C0_unbesetzt([_,_,c(wnp,_,_,_,_,_,_,_),_,_], _).
forciere_C0_unbesetzt([_,_,_,c(wnp,_,_,_,_,_,_,_),_], _).

%Workaround: es darf auch ein Pronomen in Spec-C' stehen, wenn ein Relativsatz vorliegt, und der Kasus mit dem CP-externen Regenten übereinstimmt.
%forciere_C0_unbesetzt([_,c(pron,mp(_,Genus,Numerus,nom,_,_,_,_,_,_),_,_,_,_,_,_),_,_,_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,nom,_,_,_,_,_,_)))).
%forciere_C0_unbesetzt([_,_,c(pron,mp(_,Genus,Numerus,Kasus,_,_,_,_,_,_),_,_,_,_,_,_),_,_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,Kasus,_,_,_,_,_,_)))) :- Kasus \== nom.
%forciere_C0_unbesetzt([_,_,_,c(pron,mp(_,Genus,Numerus,Kasus,_,_,_,_,_,_),_,_,_,_,_,_),_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,Kasus,_,_,_,_,_,_)))) :- Kasus \== nom.

forciere_C0_unbesetzt([_,c(pron,mp(_,Genus,Numerus,_,_,_,_,_,_,_),_,_,_,_,_,_),_,_,_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,_,_,_,_,_,_,_)))).
forciere_C0_unbesetzt([_,_,c(pron,mp(_,Genus,Numerus,_,_,_,_,_,_,_),_,_,_,_,_,_),_,_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,_,_,_,_,_,_,_)))).
forciere_C0_unbesetzt([_,_,_,c(pron,mp(_,Genus,Numerus,_,_,_,_,_,_,_),_,_,_,_,_,_),_], cpbesetzung(_,_,relativsatz(mp(_,Genus,Numerus,_,_,_,_,_,_,_)))).




%C0/SPEC-C'-Besetzungen einstellen.
setSpecCP(SPECC,cpbesetzung(_,_,Satzart),cpbesetzung(SPECC,_,Satzart)).

setC0(COMPC0,cpbesetzung(SPECC,_,Satzart),cpbesetzung(SPECC,COMPC0,Satzart)).


%welche C0/SPEC-C'-Besetzungen sind für diese Satzart zulässig?
erfuelltSatzartVorgabe(cpbesetzung(SPECC,verb,matrixsatz)) :- SPECC \== wnp, SPECC \== wpp, artVereinbarkeit(SPECC,np).
erfuelltSatzartVorgabe(cpbesetzung(cp,verb,matrixsatz)).
erfuelltSatzartVorgabe(cpbesetzung(wnp,verb,matrixsatz)).
erfuelltSatzartVorgabe(cpbesetzung(pp,verb,matrixsatz)).
erfuelltSatzartVorgabe(cpbesetzung(empty,verb,matrixsatz)).

erfuelltSatzartVorgabe(cpbesetzung(np,verb,nebensatz)).
erfuelltSatzartVorgabe(cpbesetzung(wnp,empty,nebensatz)).
erfuelltSatzartVorgabe(cpbesetzung(empty,c0,nebensatz)).

erfuelltSatzartVorgabe(cpbesetzung(pron,empty,relativsatz(_))).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Rekursion verhindern
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rekursionsFilter(cpbesetzung(_,_,matrixsatz)).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Adjunktionsstrukturen
%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fehleranalyse
% die hier stehenden zusätzlichen Patterns weiter oben definierter Funktionen repräsentieren allesamt grammatisch falsche Satzstrukturen,
% sozusagen der Giftschrank unter den Funktionsdefinitionen
% würden die fehlerhaften Strukturen gar nicht gematcht, so könnten sie auch nicht aufgezeigt werden
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Vereinigt den Fehlerstatus mehrerer Klauseln zu einem einzigen Fehlerstatus
mergeErrorStats(F1,F2,F3) :- mergeErrorStats_Pairs(F1,F2,F3).
mergeErrorStats(F1,F2,F3,F5) :- mergeErrorStats_Pairs(F1,F2,F4), mergeErrorStats_Pairs(F4,F3,F5).

mergeErrorStats_Pairs([ok],[ok],[ok]) :- !.
mergeErrorStats_Pairs(F1,[ok],F1) :- F1 \== [ok].
mergeErrorStats_Pairs([ok],F2,F2) :- F2 \== [ok].
mergeErrorStats_Pairs(F1,F2,F3) :- F1 \== [ok], F2 \== [ok], append(F1,F2,F3).



%Bestätigung des Fehlerstatus
dStrukturSchlingeLeer(subkatChan(_,_),ErrStat) :- ErrStat \= [ok].


%FEHLERHAFTE Matchings der Kongruenzfunktion
%Numerus ist falsch
kongruenz(subj,ART1,mp(Person1,Numerus1,_,nom,_,_,_,_,_,_),subkatChan(MP,ARGS),subkatChan(MP,ARGSreduced),[numErr]) :- lastArg(ARGS, subj(ART2,nom,Person2,Numerus2)), Numerus1 \== Numerus2, artVereinbarkeit(ART1,ART2), personKongruenz(Person1,Person2), allbutlast(ARGS,ARGSreduced). 

%Objekt fehlt oder falsches Objekt
kongruenz(subj,_,mp(_,_,_,nom,_,_,_,_,_,_),subkatChan(MP,ARGS),subkatChan(MP,ARGSreduced),[missingObj]) :- lastArg(ARGS, obj(_,_)), allbutlast(ARGS,ARGSreduced).

%Objekt zu viel
%kongruenz(obj,ART1,mp(_,_,_,_,_,_,_,_,_,_),subkatChan(MP,ARGS),subkatChan(MP,ARGS),[tooManyObj]) :- xxx, lastArg(ARGS, subj(ART2,_,_,_)), artVereinbarkeit(ART1,ART2).

%Numerus-Kongruenz zwischen Anapher und ihrem Antezedens schlägt fehl. Z.B. statt "Peter <--> sich" "Peter <--> einander"
closeRectDom(rectDom(alpha(mp(_,Numerus1,_,_,_,_,_,_,_,_)),rho,omega(mp(_,Numerus2,_,_,_,_,_,_,_,_))),rectDom(noAlpha,noRho,noOmega),[anapherKongruenzFail]) :- Numerus1 \== Numerus2, !.
