# -*- coding: utf-8 -*-
# Erstellt den Lexikoneintrag für ein neues Wort mittels eines interaktiven Menüs
# AUTOR: Sebastian Behr

import sys
import tty
import termios


#Statt der eigentlichen Indizes schreiben wir Variablennamen, damit der Code lesbar bleibt
submenuname = 0
beschreibung = 0
wortart = 0
konstante = 1
person = 1
numerus = 2
genus = 3
kasus = 4
komparation = 5
modus = 6
tempus = 7
flexion = 8
verbart = 9
praet_bildung = 10


anzahl_objekte = 0
objekt_kategorie = 1
objekt_kasus = 2
reduzierter_objekt_kasus = 3
objekt_pflicht = 4
ana_kategorie = 5
wwort_kategorie = 6


eintraege = [

["Lexikalische Kategorie",["Nomen","n0"],["Adjektiv","a0"],["Verb","v0"],["Präposition","p0"],["Adverb","adv0"],["Determinator/Artikel","det"],["Pronomen","pron"],["Possessivpronomen","pospron"],["Anapher","ana"],["W-Wort","wwort"],["Satzeinleitende Konjunktion","c0"],["Koordinierende Konjunktion","koord0"], ["Partikel","part"]],

["Person",["1. Person","1"], ["2. Person","2"], ["3. Person","3"]],

["Numerus",["Singular","sg"], ["Plural","pl"]],

["Genus",["Maskulin","mas"],["Feminin","fem"],["Neutrum","neu"]],

["Kasus",["Nominativ","nom"],["Genitiv","gen"],["Dativ","dat"],["Akkusativ","akk"]],

["Komparation",["Positiv","pos"],["Komparativ","com"],["Superlativ","sup"]],

["Modus",["Indikativ","ind"],["Konjunktiv 1","kj1"],["Konjunktiv 2","kj2"]],

["Tempus",["Präsens","praes"],["Präteritum","praet"]],

["Flexionsart",["finit","fini"], ["Infinitiv","inf"], ["Partizip I","part1"], ["Partizip II","part2"]],

["Verbart",["Vollverb","voll"],["Accusativ cum Infinitivo","aci"],["Modalverb (regiert Infinitiv-Ergänzung)","modal"],["Modalitätsverb (regiert Infinitiv-mit-\'zu\'-Ergänzung)","modalit"]],

["Bildung des Präteritums",["Präteritum mit " + chr(34) + "haben" + chr(34), "ha"], ["Präteritum mit " + chr(34) + "sein" + chr(34),"is"]],

]

komponente_2_objekte = [

["Anzahl der Objekte", ["<keins>",0], ["1",1], ["2",2], ["3",3] ],

["Lexikalische Kategorie des Objektes", ["NP","np"], ["PP","pp"], ["CP","cp"] ],

["Kasus",["Nominativ","nom"],["Genitiv","gen"],["Dativ","dat"],["Akkusativ","akk"]],

["Kasus",["Dativ","dat"],["Akkusativ","akk"]],

["Objekt verpflichtend?",["Ja","m"],["Nein, nur optional","o"] ],

["Kategorienzugehörigkeit der Anapher",["Nominalphrase","anaNP"],["Präpositionalphrase","anaPP"] ],

["Kategorienzugehörigkeit des W-Wortes",["Nominalphrase","wnp"],["Präpositionalphrase","wpp"] ],

]

##############


#Submenü auf Bildschirm ausgeben, der Benutzer muss anschließend eine erlaubte Option wählen
def menu_eintrag(eintraege,e):
	
	global beschreibung, konstante
	
	taste = ""
	
		
	print "\n=========   " + eintraege[e][submenuname] + "   =========\n\n"

	for x in range(1,len(eintraege[e])):
		print "    [" + `x` + "] " + eintraege[e][x][beschreibung]


	while taste == "":
		taste = input("\n===== Bitte wählen: ")
		
		try:
		    tasteInt = int(taste)
		    if tasteInt < 1 or tasteInt > x: taste = ""
	        except:
		    taste = ""
		
	
	
	print "[" + str(taste) + "]"
	
        return eintraege[e][tasteInt][konstante]



#baut aus einem Wort und einer Attributliste eine Zeile für das Lexikon
def word_2_zeile(w,attribute):
	global eintraege,beschreibung,wortart,konstante,person,numerus,genus,kasus,komparation,modus,tempus,flexion,verbart,praet_bildung
	
	z = eintraege[wortart][attribute[wortart]][konstante] + '(mp('
	
	
	for a in xrange(1,len(attribute)):
		
		if attribute[a] != -1:
			z = z + eintraege[a][attribute[a]][konstante]
		else:
			z = z + '_'
			
		if a < len(attribute) - 1:
			z = z + ","
		
	z = z + ")) --> [" + w + "]."
	
	return z
	

#Wandelt einen Lexikoneintrag in eine Attributliste um
def zeile_2_word(z):
	global eintraege,submenuname,beschreibung,wortart,konstante,person,numerus,genus,kasus,komparation,modus,tempus,flexion,verbart,praet_bildung
	
	l = z.replace('(mp(',',')
	
	l = l[:l.find(")")]
	
	l = l.split(',')
	
	#Workaround für zusätzliche Komponenten, z.B. bei Verben
	if l[0:2] != "v0": l.append([])
	
	for a in xrange(0,len(l) - 1):
		
		if l[a] != "_":
			for b in xrange(1,len(eintraege[a])):
				if l[a] == eintraege[a][b][konstante]:
					print eintraege[a][submenuname] + ": " + eintraege[a][b][beschreibung]
	
	
	return l


#x = word_2_zeile('schiff',[1,-1,1,3,4,-1,-1,-1,-1,-1,-1])
#print x
#print zeile_2_word(x)



#Steuerung der Menü-Bäume
def main(wort):
	
	global eintraege,komponente_2_objekte,submenuname,beschreibung,wortart,konstante,person,numerus,genus,kasus,komparation,modus,tempus,flexion,verbart,praet_bildung,anzahl_objekte, objekt_kategorie, objekt_kasus, reduzierter_objekt_kasus, objekt_pflicht, ana_kategorie, wwort_kategorie
		

	#choice = []

	print "==== Einzuordnendes Wort:   " + wort + "   ========="

	#Wortart auswählen
	#choice.append(menu_eintrag(wortart))
	choice1 = menu_eintrag(eintraege,wortart)

	result = choice1

	#... je nach Wahl muss der Benutzer andere Auswahlen treffen
	#c0, koord0, part, adv benötigen kein morphologisches Paket
	if choice1 == "n0":
		menubaum = [-1,numerus,genus,kasus,-1,-1,-1,-1,-1,-1]
	elif choice1 == "a0":
		menubaum = [-1,numerus,genus,kasus,komparation,-1,-1,-1,-1,-1]
	elif choice1 == "v0":
		
		#das Fehlen von Flexionsmerkmalen schließt auch die Anwesenheit der Merkmale MODUS und TEMPUS aus
		choice_flexion = menu_eintrag(eintraege,flexion)
		
		if choice_flexion == "fini":
			menubaum = [person,numerus,-1,-1,-1,modus,tempus,choice_flexion,verbart,praet_bildung]
		else:
			menubaum = [-1,-1,-1,-1,-1,-1,-1,choice_flexion,verbart,praet_bildung]		
		
	elif choice1 == "p0":
		menubaum = [-1,numerus,-1,kasus,-1,-1,-1,-1,-1,-1]
	elif choice1 == "det":
		menubaum = [-1,numerus,genus,kasus,-1,-1,-1,-1,-1,-1]
	elif choice1 == "pron":
		menubaum = [person,numerus,genus,kasus,-1,-1,-1,-1,-1,-1]
	elif choice1 == "pospron":
		menubaum = [person,numerus,genus,kasus,-1,-1,-1,-1,-1,-1]
	elif choice1 == "ana":
		menubaum = [person,numerus,-1,-1,-1,-1,-1,-1,-1,-1]	
	elif choice1 == "wwort":
		menubaum = [-1,-1,-1,kasus,-1,-1,-1,-1,-1,-1]
	else:
		menubaum = []
		
		


	#Wenn ein morphologisches Paket benötigt
	if menubaum <> []:
		result = result + "(mp("

       		#Morphologisches Paket bauen
		for x in range (0,len(menubaum)):
			menu_num = menubaum.pop(0)
	
			if menu_num == -1:
				result = result + "_,"
			elif menu_num == "fini" or menu_num == "inf" or menu_num == "part1" or menu_num == "part2":
				result = result + menu_num + ","
			else:
				choice2 = menu_eintrag(eintraege,menu_num)
				result = result + choice2 + ","


		result = result[:- 1] + ")"


        result_obj = ""
	
	
	#v0, ana, wwort haben auch noch eine 2. Komponente!!!
	#bei Verben muss auch noch die Objektliste abgefragt werden:
	if choice1 == "v0":
		choice3 = menu_eintrag(komponente_2_objekte,anzahl_objekte)
		
		result_obj = ", ["
		
		for x in xrange(0,choice3):
			result_obj = result_obj + "obj("
			
			#Kategorien: np, pp, cp
			choice4 = menu_eintrag(komponente_2_objekte,objekt_kategorie)
			result_obj = result_obj + choice4  + ","
			
			#Kasus
			if choice4 == "np":
				result_obj = result_obj + menu_eintrag(komponente_2_objekte,objekt_kasus)  + ","
			elif choice4 == "pp":
				result_obj = result_obj + menu_eintrag(komponente_2_objekte,reduzierter_objekt_kasus)  + ","
			else:
				result_obj = result_obj + "irr,"
			
			
			#m, o ?
			result_obj = result_obj + menu_eintrag(komponente_2_objekte,objekt_pflicht)  + ")"
			
			#Wir brauchen Kommas zum Abtrennen
			if x < choice3 - 1: result_obj = result_obj + ","
		
			
		result_obj = result_obj + "])"
		
	elif choice1 == "ana":
		
		result_obj = "," + menu_eintrag(komponente_2_objekte,ana_kategorie) + ")"
		
	elif choice1 == "wwort":
		
		result_obj = "," + menu_eintrag(komponente_2_objekte,wwort_kategorie) + ")"
		
	#wenn MP, aber keine 2. Komponente	
	elif choice1 <> "c0" and choice1 <> "koord0" and choice1 <> "part" and choice1 <> "adv":
		
		result_obj = ")"
	
	
	result = result + result_obj + " --> [" + wort + "]."
	
	return result


