# -*- coding: iso-8859-1 -*-
# verschiedene Aspekte der Skalierbarkeit testen, insbesonders was die Gre des Lexikons angeht
# AUTOR: Sebastian Behr

import datetime
import os
import random
import generate_dynlex
import entry_2_lex

#kommando = 'pl -f ~/Uni/Diplomarbeit/workspace/Grammatik3/z12.pl -g go3 -t halt'

beschreibung = 0
konstante = 1
kategoriengroesse = 500000
satzgroesseSOLL = 20.0
satzgroesseIST = 0
lexikoneintraegeIST = 0
flexionRepeatProb = 0.1
kategorien = ["v0","n0","a0","p0"]


eintraege = [

["Lexikalische Kategorie",["Nomen","n0"],["Adjektiv","a0"],["Verb","v0"],["Prposition","p0"],["Konjunktion","c0"]],

["Person",["1. Person","1"], ["2. Person","2"], ["3. Person","3"]],

["Numerus",["Singular","sg"], ["Plural","pl"]],

["Genus",["Maskulin","mas"],["Feminin","fem"],["Neutrum","neu"]],

["Kasus",["Nominativ","nom"],["Genitiv","gen"],["Dativ","dat"],["Akkusativ","akk"]],

["Komparation",["Positiv","pos"],["Komparativ","com"],["Superlativ","sup"]],

["Modus",["Indikativ","ind"],["Konjunktiv 1","kj1"],["Konjunktiv 2","kj2"]],

["Tempus",["Prsens","praes"],["Prteritum","praet"]],

["Flexionsart",["finit","fini"], ["Infinitiv","inf"], ["Partizip I","part1"], ["Partizip II","part2"]],

["Verbart",["Vollverb","voll"],["Accusativ cum Infinitivo","aci"],["Verb mit Infinitiv-Ergnzung","inferg"],["Verb mit zu-Infinitiv-Ergnzung","zuinferg"]],

["Bildung des Prteritums",["Prteritum mit " + chr(34) + "haben" + chr(34), "ha"], ["Prteritum mit " + chr(34) + "sein" + chr(34),"se"]],

]

#Wort aus Lexikoneintrag isolieren
def stripEntry(e):
	w = e[e.index("-->") + 5 :]
	w = w.replace("].","")
	w = w.replace("\n","")
	
	return w

#ein zuflliges Lexikon erstellen. Mit einer sehr kleinen W'keit werden einige Worte daraus ausgewhlt, die dann den Satz bilden
def create_RANDOM_lex():
	
	global flexionRepeatProb, kategoriengroesse, satzgroesseSOLL, lexikoneintraegeIST, kategorien
	
	lex = open('yyy.txt','w',1)  #lex_ALL.pl
	
	lexikoneintraegeIST = 0
	
		
	print "Satz der Lnge",int(satzgroesseSOLL),"aus",kategoriengroesse*len(kategorien),"Worten"
	
	for x in kategorien:
		
		
		#zum Backtracking-Test
		#staticMP = randomMP(x) + " --> ["
		
				
		for letter in "abcdefghijklmnopqrstuvwxyz":
			#jeder Anfangsbuchstabe soll in etwa gleich oft vorkommen. Wir mssen die Anfangsbuchstaben nacheinander abarbeiten, damit das Lexikon halbwegs sortiert ist, und die die Suchzeiten fr entry_2_lex nicht zu kurz
			if random.random() > 0.5: richtung = -1
			else: richtung = 1
			
			kontingent = int((kategoriengroesse / 26.0) * (1 + (0.05 * richtung * random.random()) ))			
			w = ""
			
			#fr einen Anfangsbuchstaben die Eintrge schreiben
			for z in xrange(0,kontingent):
								
				e = randomMP(x) + " --> ["
				#zum Backtracking-Test
				#e = staticMP
				
				#mit einer geringen W'keit sind mehrere Flexionsformen oberflchenidentisch, haben jedoch unterschiedliche morphologische Eigenschaften
				if random.random() > flexionRepeatProb or w == "":
					w = randomWord(2,15)
			
				e = e + letter + w + "].\n"
				lex.write(e)
				lexikoneintraegeIST = lexikoneintraegeIST + 1

		
		#Abtrennung zwischen verschiedenen lexikalischen Kategorien
		lex.write("\n")
	
	
	#Zum Backtracking
	#lex.write("n0(mp(1,sg,mas,dat,sup,kj2,praet,part2,zuinferg)) --> [hamburg].\n")	
	#lex.write("n0(mp(1,sg,mas,dat,sup,kj2,praet,part2,zuinferg)) --> [mondfahrt].\n")
	#lex.write("a0(mp(1,sg,mas,dat,sup,kj2,praet,part2,zuinferg)) --> [supergut].\n")
	
	lex.close()


def randomWord(min,max):
	w = ""
	r = random.randrange(min,max)
	
	for y in range(0,r):
		w = w + random.choice("abcdefghijklmnopqrstuvwxyz")
		
	return w
	


def randomMP(kat):
	global eintraege, beschreibung, konstante
	
	mp = ""
	
	mp = "" + kat + "(mp("
	
	for x in range(1,10):
		ran = random.randrange(1,len(eintraege[x]))
		mp = mp + eintraege[x][ran][konstante] + ","
	
	mp = mp[:len(mp) - 1] + "))"	
	
	return mp
	
def randomZeile():
	global kategorien

	return randomMP(random.choice(kategorien)) + " --> [" + randomWord(2,15) + "]."
	


#Sucht aus dem Lexikon einen Satz aus willkrlichen Worten aus
def randomSentence():
	global kategoriengroesse, satzgroesseSOLL, satzgroesseIST, kategorien
	
	satzgroesseIST = 0
	s = []
	
	lex = open('yyy.txt','r',1)
	
	for line in lex:
		if len(line) > 1 and random.random() < (satzgroesseSOLL / (kategoriengroesse * len(kategorien))):
			w = stripEntry(line)
			s.append(w)
			satzgroesseIST = satzgroesseIST + 1
			
	
	lex.close()
	
	return s


def time_2_seconds(t):
	
	str_t = str(t)
	
	sec_t = float(str_t[0:1]) * 3600 + float(str_t[2:4]) * 60 + float(str_t[5:])
	
	return sec_t

def seconds_2_str(t):
	
	str_t = str(t)
	str_t = str_t.replace(".",",")
	
	return str_t
	
	


##########################################################
#os.system(kommando)

##########################################################

def statistik_dynlex():
	global kategoriengroesse, kategorien, satzgroesseSOLL, satzgroesseIST, lexikoneintraegeIST
		
	groessen = [4000000]
	#2000000
	#500,5000,
	#groessen = [50000,500000]
	#groessen = [4000000]
	
	#5.0,10.0,20.0,40.0,
	satzgroessen = [80.0]
	repeating = 100
	
	statfile = open('stat.csv','w',1)
	statfile.write('STATISTISCHE AUSWERTUNG DER GENERIERUNG DER DYNAMISCHEN LEXIKONS\n')
	statfile.write('ANZAHL DER WIEDERHOLUNGEN FR JEDES SATZLNGE/LEXIKONGRSSE-VERHLTNIS: ' + str(repeating) + '\n')
	
	for x in groessen:
		
		#nur dann nicht auskommentieren, wenn sehr groe Lexikongren
		#kategoriengroesse = x
		#create_RANDOM_lex()
		
		for y in satzgroessen:
			
			#nur dann nicht auskommentieren, wenn sehr kleine Lexikongren
			kategoriengroesse = x
			satzgroesseSOLL = y
			create_RANDOM_lex()
			
			statfile.write('\n\n[VORGABE: SATZ DER LNGE ' + str(int(satzgroesseSOLL)) +' AUS ' + str(kategoriengroesse*len(kategorien)) + ' WORTEN]\n')
			statfile.write('TATSCHLICHE LEXIKONGRSSE:;;' + str(lexikoneintraegeIST) + '\n')

			satzgroesseARRAY = []
			zeitARRAY = []
			
			for z in xrange(0,repeating):
				
				if z % 10 == 0: print str(z),"Durchlufe"
				
				satzworte = randomSentence()
				startzeit = datetime.datetime.now()
				generate_dynlex.main("yyy.txt","yyy_dyn.txt",satzworte)
				endzeit = datetime.datetime.now()
				
				satzgroesseARRAY.append(satzgroesseIST)
				zeitARRAY.append(time_2_seconds(endzeit - startzeit))
								
			statfile.write('DURCHSCHNITTLICHE SATZLNGE:;;' + str(float(sum(satzgroesseARRAY)) / len(satzgroesseARRAY)).replace(".",",") + '\n')
			statfile.write('DURCHSCHNITTLICHE ZEIT:;;' + str(sum(zeitARRAY) / len(zeitARRAY)).replace(".",",") + '\n')
			
			statfile.write('Test-Nr.;tatschliche Satzlnge;Zeit\n')
			
			for z in xrange(0,repeating):
				statfile.write(str(z + 1) + ';' + str(int(satzgroesseARRAY[z - 1])) + ";" + seconds_2_str(zeitARRAY[z - 1]) + '\n')
	
	
	
	statfile.close()
	

##########################################################

def statistik_entry2lex():
	global kategoriengroesse
	
	
	groessen = [500]#,5000,50000,500000,2000000,4000000]
	repeating = 100
	
	statfile = open('stat.csv','w',1)
	statfile.write('STATISTISCHE AUSWERTUNG DER ZUM EINFGEN NEUER EINTRGE INS LEXIKON\n')
	statfile.write('ANZAHL DER WIEDERHOLUNGEN FR JEDE LEXIKONGRSSE: ' + str(repeating) + '\n')
	
	
	
	
	for x in groessen:
		
		kategoriengroesse = x
		create_RANDOM_lex()
		
		zeitARRAY = []		
				
				
				
		statfile.write('LEXIKONGROESSE VORHER:;;' + str(os.stat('yyy.txt').st_size) + '\n')
				
		for y in xrange(0,repeating):
			
			if y % 10 == 0: print str(y),"Durchlufe"
			
			zeile = randomZeile()
						
			startzeit = datetime.datetime.now()			
			entry_2_lex.main("yyy.txt",zeile)
			endzeit = datetime.datetime.now()
			
			zeitARRAY.append(time_2_seconds(endzeit - startzeit))
		
		
		statfile.write('LEXIKONGROESSE NACHHER:;;' + str(os.stat('yyy.txt').st_size) + '\n')
		statfile.write('DURCHSCHNITTLICHE ZEIT:;;' + str(sum(zeitARRAY) / len(zeitARRAY)).replace(".",",") + '\n')
		statfile.write('Test-Nr.;Zeit\n')
		
		for z in xrange(0,repeating):
				statfile.write(str(z + 1) + ';' + seconds_2_str(zeitARRAY[z - 1]) + '\n')
	
		
		
	
	
	statfile.close()



statistik_entry2lex()

#statistik_dynlex()
