# -*- coding: iso-8859-1 -*-
# Konvertiert die Prolog-Ausgabe-Datei in ein schnes PDF :-)
# AUTOR: Sebastian Behr

from os import system
from re import *

template = ""
file_open = ""
file_close = ""
page_change = ""
page_space = ""
page_empty = ""
new_sentence = ""
page_close = ""
mp_scheme = ""


#parst die Ausgabedatei zeilenweise, und wandelt die Zeilen in LaTeX-Befehle um.
#\\n : LaTeX-Zeilenumbruch
#\n : physischer Zeilenumbruch fr die .tex-Quelldatei
def main(ausgabe,pdf):
	
	global template,file_open,file_close,page_change,page_space,page_empty,new_sentence,page_close,mp_scheme
	momentaner_satz = ""
	momentane_xp = ""
	
	
	getLatexBausteine()
	
	#Behandeln wir die Fehlerausgabe
	modus = "ok"
	teilsatzHeadline = False
		
	ausgabeFile = open(ausgabe,'r',1)
	pdfFile = open(pdf,'w',1)
	
	pdfFile.write(template)
	
	
	#einzelne Zeilen bearbeiten
	for zeile in ausgabeFile:
		
		#Alles ok
		if zeile[0:13] == "Eingabesatz: ":
			modus = "ok"
			
			pdfFile.write(page_change)
			pdfFile.write(new_sentence)
			momentaner_satz = zeile[13:].replace(", ",",")
			pdfFile.write(momentaner_satz[0 : -1] + '\\n\\n\n')
			
		elif zeile[0:7] == "Lsung" and modus == "ok":
			
			pdfFile.write("\\textbf{" + zeile[0 : -1] + "}\\n\n")
			
		elif zeile[0] == '[' and modus == "ok":
			
			pdfFile.write("\\thispagestyle{empty}\\n")
			pdfFile.write(page_space)
			pdfFile.write(prologTree_2_qtreeTree(momentaner_satz, zeile) + '\\n\n')
		
		#Details des Fehlers
		elif "ungrammatisch" in zeile:
			modus = "error"
			
			pdfFile.write(zeile + '\\n\n')
			
		elif "<-->" in zeile and modus == "error":
			pdfFile.write("\\textsc{Subjekt} $\\longleftrightarrow$ \\textsc{Verb} : \\textit{Numerus} stimmt nicht berein.\\n\\n\n")
			
		elif "OBJEKT" in zeile and modus == "error":
			pdfFile.write("\\textsc{Verb} : \\textsc{Objekt} fehlt oder ist falsch.\\n\\n\n")
			
		elif "BEZUGSWORT" in zeile and modus == "error":
			pdfFile.write("Kein passendes \\textsc{Bezugswort} fr \\textsc{Anapher} vorhanden.\\n\\n\n")
			
		elif "Lexikoneintrge" in zeile and modus == "error":
			
			pdfFile.write("\\subsection*{" + zeile[0 : -1] +"}~\\n\\n\n")			
			pdfFile.write("\\begin{tabular}{|c|c|}\n")
			pdfFile.write("\\hline \\textbf{Wort} & \\textbf{Anzahl Vorkommen im Lexikon} \\\\\n")
			
			
		elif "Eintrge im Lexikon" in zeile and modus == "error":
			
			temp1 = zeile.split(' ')
			pdfFile.write("\\hline " + temp1[0] + " & " + temp1[2] +" \\\\\n")
		
		elif "Wort nicht im Lexikon" in zeile and modus == "error":
			
			pdfFile.write("\\hline " + temp1[0] + " & \\textit{$<$nicht vorhanden$>$} \\\\\n")
		
			
		elif "Nominalphrasen analysieren" in zeile and modus == "error":
			
			#Tabelle schlieen
			pdfFile.write("\\hline\n")
			pdfFile.write("\\end{tabular}\n")
			
			pdfFile.write("\\subsection*{" + zeile +"}~\\n\\n\n")
		
		#z.B.: "der,kluge,peter"
		elif zeile[0] == '[' and zeile[-2] == ':' and modus == "error":
			
			momentane_xp = zeile[0 : -3]
						
			pdfFile.write("\\textbf{" + zeile[0 : -3] +"}\\n\\n\n")
			
		elif "Numerus" in zeile and "Kasus" in zeile and "Genus" in zeile and modus == "error":
			temp1 = mp_scheme			
			temp2 = zeile[zeile.find(':') + 1: zeile.find(',')].strip().title()
			zeile = zeile[zeile.find(',') + 1:]
			
			temp1 = temp1.replace("@N",temp2)
			
			temp2 = zeile[zeile.find(':') + 1: zeile.find(',')].strip().title()
			zeile = zeile[zeile.find(',') + 1:]
			temp1 = temp1.replace("@K",temp2)
			
			temp2 = zeile[zeile.find(':') + 1:].strip().title()
			temp1 = temp1.replace("@G",temp2)
			
			pdfFile.write(temp1)
			
		elif zeile[0] == '[' and modus == "error":
			pdfFile.write(page_empty)
			pdfFile.write(prologTree_2_qtreeTree(momentane_xp, zeile[0 : -1]) + '\\n\n')
			
			
		#Versuche Teilsatzanalyse
		elif "Versuche Teilsatz-Anaylse" in zeile:
			modus = "teilsatz"
			teilsatzHeadline = False
			
			
			pdfFile.write("\\newcounter{teilsatzloesungnr}")
			pdfFile.write("\\setcounter{teilsatzloesungnr}{0}")
			
			
		elif "erfolgreich analysiert" in zeile and modus == "teilsatz":
			
			modus = "teilsatz"
			
			if not teilsatzHeadline:
				pdfFile.write(page_change)
				pdfFile.write(page_empty)
				pdfFile.write("\\subsection*{Versuche separate Nebensatzanalyse \dots}~\\n\\n\n")
				teilsatzHeadline = True
			
			momentane_xp = (zeile.split(': ')[1])
			
			
		elif zeile[0] == "[" and modus == "teilsatz":
			
			pdfFile.write("\\addtocounter{teilsatzloesungnr}{1}")
			pdfFile.write("\\thispagestyle{empty}\n")
			pdfFile.write("\\paragraph{\\theteilsatzloesungnr. Lsung fr Teilsatz}~\\n\\n\n")
			pdfFile.write(prologTree_2_qtreeTree(momentane_xp, zeile[0 : -1]) + '\\n\n')
		
		
		elif "keine separate Nebensatz" in zeile:
			
			pdfFile.write("\\subsection*{" + zeile[0 : -1] + "}~\\n\\n\n")
		
		#print zeile		
		#print zeile[0:-2]


	
	ausgabeFile.close()
	
	pdfFile.write(file_close)	
	pdfFile.close()
	


#Bausteine aus dem Template-Ordner auslesen
def getLatexBausteine():
	
	global template,file_open,file_close,page_change,page_space,page_empty,new_sentence,page_close, mp_scheme
	
	inFile = open('latex_templates/file_open.txt','r')
	file_open = inFile.read()	
	inFile.close()
	
	inFile = open('latex_templates/file_close.txt','r')
	file_close = inFile.read()	
	inFile.close()

	inFile = open('latex_templates/page_change.txt','r')
	page_change = inFile.read()	
	inFile.close()

	inFile = open('latex_templates/page_space.txt','r')
	page_space = inFile.read()
	inFile.close()

	inFile = open('latex_templates/page_empty.txt','r')
	page_empty = inFile.read()
	inFile.close()
	
	inFile = open('latex_templates/new_sentence.txt','r')
	new_sentence = inFile.read()
	inFile.close()

	inFile = open('latex_templates/page_close.txt','r')
	page_close = inFile.read()
	inFile.close()
	
	inFile = open('latex_templates/mp_scheme.txt','r')
	mp_scheme = inFile.read()
	inFile.close()

	template = file_open + '\n' + '\n'


#Konvertiert die Klammernotation, die Prolog ausgibt, in LaTeX-Syntax des qtree-Pakets
def prologTree_2_qtreeTree(satz_pr,pr_tree):
	
	result = "\Tree "

        satz_pr = satz_pr.replace(" ", "")   #zu viele Leerzeichen entfernen, damit wir sie kontrolliert hinzufgen knnen
	satz_pr = satz_pr.replace("[", "")
	satz_pr = satz_pr.replace("]", "")
	satz_pr_list = satz_pr.split(',')
	
	#letzten Zeilenumbruchentfernen
	if satz_pr_list[-1][-1] == "\n":
		satz_pr_list[-1] = satz_pr_list[-1][:-1]
		

	if pr_tree[2] == '=': pr_tree = pr_tree[5:]
	pr_tree = pr_tree.replace("' ;", "")
	pr_tree = pr_tree.replace("[", "[ ")
	pr_tree = pr_tree.replace("]]", "] ]")
	pr_tree = pr_tree.replace("e]", "e ]")
	pr_tree = pr_tree.replace("N]", "N ]")
	pr_tree = pr_tree.replace("A]", "A ]")
	pr_tree = pr_tree.replace("V]", "V ]")
	pr_tree = pr_tree.replace("P]", "P ]")
	pr_tree = pr_tree.replace("Adv]", "Adv ]")
	#pr_tree = pr_tree.replace("`", "\'")
	pr_tree_split = pr_tree.split(' ')

	#print match('[A-Z\.\-]+$',"PRON.-NP") != None
	#PRON\.\-NP$
	#[A-Z\.\-]+$

	for element in pr_tree_split:
		
		#soll genau die Bltter der X-Bar-Struktur erfassen!
		#Dach fr NP-Unterarten
		if match('[A-Z]{1,5}\.?\-[A-Z]{2}$',element) != None:
			result = result + "\\qroof{" + satz_pr_list[0] + "}." + element + " "
			del satz_pr_list[0]
		
		
		#Typ-0-Adjunktion | lexikalische Basiskategorien / weitere lexikalische Kategorien
		elif match('([A-Z]\+)+[A-Z]$|[A-Z]$|Adv$|Det$|Koord$|Part$|PosPron$',element) != None:
			result = result + "[." + element + " " + satz_pr_list[0] + " ] "
			del satz_pr_list[0]
		
		elif element == "[":
			result = result + element
			result = result + "."
		else:
			result = result + element
			result = result + " "

	return result

